/* This is the crescendo  function file. all my comman */
/* functions will be available from here. boy I  */
/* hope the works rigth. */

#include "cr_functions.h"
#include "crescendo.h"
#include <zvt/vt.h>
#define MAX_BUF 1024

gint inputid; 
gboolean copying;
gboolean escaped;
char *crescendo_font;

/* prototypes */
void init_scrollback();
void del_scrollback();

void dest_window (GtkWidget *widget) {
        gtk_widget_destroy(widget);
}

void delete_event (GtkWidget *widget, GdkEvent *event, gpointer data) {
        exit_app(widget, data);
}

void exit_app (GtkWidget *widget, gpointer data) {
        input_push("/quit\n", 6);
        gtk_main_quit();
}

void dest_main_window (GtkWidget *widget) {
  gtk_widget_destroy (WinMain);
}

void input_push(gchar *data, gint len)
{
	write(pipes[1], data, len);
}

void input_parse( GtkWidget *widget, gpointer data ) {  
        gchar *input, *temp;
        
        if(data != FROM_RETURN) return; /* don't bother yet */
        input = gtk_editable_get_chars(GTK_EDITABLE(widget), 0, -1);
        if(strcmp(input, "/quit") == 0) {
        	exit_app(NULL, NULL);
                /* How did we get here? */
                input_push("/quit\n", 6);
                return;
        } else if(strcmp(input, "/t1") == 0) {
                init_scrollback();
                return;
        } else if(strcmp(input, "/t2") == 0) {
                del_scrollback();
                return;
        }
        strcpy(temp = (gchar *)g_malloc(strlen(input)+2),input);
 	strcat(temp, (gchar *)"\n");
        input_push(temp, strlen(temp));
        gtk_editable_delete_text(GTK_EDITABLE(widget), 0, -1);
        gtk_editable_set_position(GTK_EDITABLE(widget), 0);
        g_free(input); /* do we actually free this... research this, David */
	g_free(temp);
}

void input_read ( gpointer data, gint source, GdkInputCondition condition )
{
        
  gint length;
  gchar buffer[MAX_BUF+1];
  gchar zvt_buf[(MAX_BUF*2)+1]; 
  gint i;
  static  gint i3 = 0;

  length = read(pipes[0], buffer, MAX_BUF);
  
  if(length == 0){
    gdk_input_remove(inputid);
    return;
  }
  
  /* Now to clean up buffer */
  i=0;
  i3=0;
  
  while (i < length) {
    if (buffer[i] == '\n') {
      zvt_buf[i3] = '\r';
      zvt_buf[i3 + 1] = '\n';
      i3 += 2;
    } else {
      zvt_buf[i3] = buffer[i];
      i3++;
    }
    i++;
  }
  zvt_buf[i3]=0x00;
  zvt_term_feed(ZVT_TERM(trmOutput), zvt_buf, i3);
}

void startup_app ( int argc, char *argv[] ) {
	
	copying = TRUE;
  	escaped = FALSE;
  	
	read_config();
	
	find_crescendo_bin();	
	setup_window_create();
}


void size_allocate (GtkWidget *widget) {

        ZvtTerm *term;
        GnomeApp *app;
        XSizeHints sizehints;

        g_assert (widget != NULL);
        term = ZVT_TERM (widget);

        app = GNOME_APP (gtk_widget_get_toplevel (GTK_WIDGET (term)));
        g_assert (app != NULL);

        sizehints.base_width = 
          (GTK_WIDGET (app)->allocation.width) +
          (GTK_WIDGET (term)->style->klass->xthickness * 2) -
          (GTK_WIDGET (term)->allocation.width);

        sizehints.base_height =
          (GTK_WIDGET (app)->allocation.height) +
          (GTK_WIDGET (term)->style->klass->ythickness * 2) -
          (GTK_WIDGET (term)->allocation.height);

        sizehints.width_inc = term->charwidth;
        sizehints.height_inc = term->charheight;
        sizehints.min_width = sizehints.base_width + sizehints.width_inc;
        sizehints.min_height = sizehints.base_height + sizehints.height_inc;

        sizehints.flags = (PBaseSize|PMinSize|PResizeInc);

        XSetWMNormalHints (GDK_DISPLAY(),
                           GDK_WINDOW_XWINDOW (GTK_WIDGET (app)->window),
                           &sizehints);
        gdk_flush ();

}

/* read in the crescendo config file */
void read_config (void) {
	
	
	gnome_config_push_prefix("/Crescendo/");
	splash = (gint)gnome_config_get_int_with_default("Setup/splash=1", NULL);
	trmfont = gnome_config_get_string_with_default
	   ("Setup/trmfont=-misc-fixed-medium-r-*-*-*-140-*-*-*-*-*-*",
	    NULL);
}

/* Build Button Bar Function
 * This is where are the button creation is done
 * for the main button bar
 */
   
/*
void build_button_bar(GtkWidget *parent)
 {
   
	GtkWidget *conButton;
        GtkWidget *button1;
        GtkWidget *button2;
        GtkWidget *butOption;

        
	conButton = gtk_hbox_new(FALSE, 0);
        gtk_box_pack_start (GTK_BOX (parent), conButton, FALSE, FALSE, 0);
                        

                        
        button1 = gtk_button_new_with_label ("Test Button");
        gtk_signal_connect (GTK_OBJECT (button1), "clicked", GTK_SIGNAL_FUNC (test_button_push), (gpointer)"Test Button");
        gtk_box_pack_start(GTK_BOX(conButton), button1, FALSE, FALSE, 0);
        gtk_widget_show(button1);
                                                        

                                                        
        butOption = gtk_button_new_with_label ("Options");
        gtk_signal_connect (GTK_OBJECT (butOption), "clicked", GTK_SIGNAL_FUNC(show_window_WinSetup), (gpointer) "Option Button");
        gtk_box_pack_start(GTK_BOX(conButton), butOption, FALSE, FALSE, 0);
        gtk_widget_show(butOption);
                                                                                        
                                                              
        button2 = gtk_button_new_with_label ("Exit");
        gtk_signal_connect (GTK_OBJECT (button2), "clicked", GTK_SIGNAL_FUNC (exit_app), (gpointer) "Exit Button");
        gtk_box_pack_start(GTK_BOX(conButton), button2, FALSE, FALSE, 0);
        gtk_widget_show(button2);
                                

                                
        gtk_widget_show(conButton);
}

*/

void build_status_bar(GtkWidget *parent)
{
	GtkWidget *conStatus;
	GtkWidget *lblTimer;
	GtkWidget *txtTimer;
	GtkWidget *lblWorld;

        conStatus = gtk_hbox_new(FALSE, 0);
        gtk_box_pack_start(GTK_BOX (parent), conStatus, TRUE, TRUE, 0);

/* Session Timer */

        lblTimer = gtk_frame_new("Session Timer: ");
        gtk_box_pack_start(GTK_BOX(conStatus), lblTimer, FALSE, FALSE, 0);
        gtk_container_border_width(GTK_CONTAINER(lblTimer), 2);
        gtk_widget_set_usize(lblTimer, 100, 50 );
        gtk_widget_show(lblTimer);
        txtTimer = gtk_clock_new(GTK_CLOCK_REALTIME);
        gtk_container_add(GTK_CONTAINER(lblTimer), txtTimer);
        gtk_widget_show(txtTimer);
                                                        
/* End Session Timer */

/* World Printout */

        lblWorld = gtk_frame_new("Site: ");
        gtk_box_pack_start(GTK_BOX(conStatus), lblWorld, FALSE, FALSE, 0);
        gtk_container_border_width(GTK_CONTAINER(lblWorld), 2);
        gtk_widget_set_usize(lblWorld, 200, 50);
        gtk_widget_show(lblWorld);
        txtWorld = gtk_label_new("none");
        gtk_container_add(GTK_CONTAINER(lblWorld), txtWorld);
        gtk_widget_show(txtWorld);
                                                
 /* End World Printout */

	gtk_widget_show(conStatus);
}

/* Mucho thanks to Michal Zucchi for this function(i may have tweaked it a bit though) -ebernhar 2/7/99 */
void zvt_term_duplicate_scrollback(ZvtTerm *origional, ZvtTerm *dest) {
	struct vt_line *wn, *nn, *on;
	
	/* clear whats there */
	vt_scrollback_set(&dest->vx->vt, 0);
	wn = (struct vt_line *)origional->vx->vt.scrollback.head;
	/*
	wn = &origional->vx->vt.scrollback.head;
	*/
	nn = wn->next;
	while(nn) {
		on = g_malloc(VT_LINE_SIZE(wn->width));
		on->line = wn->line;
		on->width = wn->width;
		on->modcount = wn->modcount;
		memcpy(on->data, wn->data, 
		       wn->width * sizeof(uint32));
		vt_list_addtail(&dest->vx->vt.scrollback, (struct vt_listnode *)on);
		wn = nn;
		nn = wn->next;
	}
	dest->vx->vt.scrollbacklines = origional->vx->vt.scrollbacklines;
	dest->vx->vt.scrollbackmax   = origional->vx->vt.scrollbackmax;
	
	return;
}

void init_scrollback() {
	extern gushort blu[], red[], grn[];
	int width, height;

	g_return_if_fail(trmScrollback == NULL);
	g_return_if_fail(vscrollbar != NULL);
	g_return_if_fail(vpane != NULL);
	g_return_if_fail(trmOutput != NULL);

	/* Set up trmScrollback to be just like trmOutput */
	trmScrollback = zvt_term_new();
	zvt_term_set_size(ZVT_TERM(trmScrollback), 10, 20);
	zvt_term_set_scrollback(ZVT_TERM(trmScrollback), 2000);
	zvt_term_set_bell(ZVT_TERM(trmScrollback), TRUE);
	zvt_term_set_fonts(ZVT_TERM(trmScrollback),
			ZVT_TERM(trmOutput)->font,
			ZVT_TERM(trmOutput)->font_bold);

	height = GTK_WIDGET(vpane)->allocation.height;
	width = GTK_WIDGET(vpane)->allocation.width;

	gtk_paned_add1(GTK_PANED(vpane), trmScrollback);

	/* Move the vscrollbar over to the new terminal */
	gtk_range_set_adjustment(GTK_RANGE(vscrollbar),
						 ZVT_TERM(trmScrollback)->adjustment);
	gtk_paned_set_position(GTK_PANED(vpane),
					(GTK_PANED(vpane)->max_position +
					 GTK_PANED(vpane)->min_position)/ 2);

	/* NOTE: this is my own function, not a zvt_term function -ebernhar 2/7/99 */
	zvt_term_duplicate_scrollback(ZVT_TERM(trmOutput), ZVT_TERM(trmScrollback));	                         

	gtk_widget_realize(trmScrollback);

	zvt_term_set_color_scheme(ZVT_TERM(trmScrollback), red, grn, blu);

	gtk_widget_show(trmScrollback);

	gtk_widget_set_usize(GTK_WIDGET(vpane), width, height);
}

void del_scrollback() {
	g_return_if_fail(trmScrollback != NULL);
	g_return_if_fail(vpane != NULL);
	g_return_if_fail(vscrollbar != NULL);
	g_return_if_fail(trmOutput != NULL);
	
	/* Move the vscrollbar back */
	gtk_range_set_adjustment(GTK_RANGE(vscrollbar),
						 ZVT_TERM(trmOutput)->adjustment);
	
	/* Get rid of trmScrollback */
	gtk_widget_hide(trmScrollback);
	gtk_widget_destroy(trmScrollback);
	trmScrollback = NULL;
	
	gtk_paned_set_position(GTK_PANED(vpane), 0);
	                         
	
}

void zvt_term_scroll (ZvtTerm *term, int n)
{
  gfloat new_value = 0;
 
  if (n)
    {
      new_value = term->adjustment->value + (n * term->adjustment->page_size);
    }
  else if (new_value == (term->adjustment->upper - term->adjustment->page_size))
    {
      return;
    }
  else
    {
      new_value = term->adjustment->upper - term->adjustment->page_size;
    }
 
  gtk_adjustment_set_value (
      term->adjustment,
      n > 0 ? MIN(new_value, term->adjustment->upper- term->adjustment->page_size) :
      MAX(new_value, term->adjustment->lower));
}

void cresc_key_press(GtkWidget *widget, GdkEventKey *event) {
	g_return_if_fail(widget != NULL);

	switch(event->keyval) {
		case GDK_KP_Page_Up:
		case GDK_Page_Up:
			if(trmScrollback == NULL)
				init_scrollback();
			else
				zvt_term_scroll(ZVT_TERM(trmScrollback), -1);
			gtk_signal_emit_stop_by_name(GTK_OBJECT(widget),
							"key_press_event");
			break;
		case GDK_KP_Page_Down:
		case GDK_Page_Down:
			zvt_term_scroll(((trmScrollback == NULL) ? 
					ZVT_TERM(trmOutput) : 
					ZVT_TERM(trmScrollback)), 1);
			/* Check to see if they are at the bottom 
			   of the scrollback now */
			if(trmScrollback == NULL)
				break;
			if(ZVT_TERM(trmScrollback)->vx->vt.scrollbackoffset  == 0)
				del_scrollback();
			gtk_signal_emit_stop_by_name(GTK_OBJECT(widget),
							"key_press_event");
			break;
		case GDK_Up:
			printf("UP\n");
			break;
		case GDK_Down:
			printf("DOWN\n");
			break;
		default:
			break;
	}

	if((event->state & (GDK_CONTROL_MASK|GDK_MOD1_MASK)) == 0 &&
	   event->keyval != GDK_Control_L &&
	   event->keyval != GDK_Control_L &&
	   event->keyval != GDK_Meta_L    &&
	   event->keyval != GDK_Meta_L    &&
	   event->keyval != GDK_Alt_L     &&
	   event->keyval != GDK_Alt_R) {
		/* Normal key was pressed, move focus */
		gtk_widget_grab_focus(entInput);        
	}

	return;
}
