#include "setup.h"


char *newfont;

void font_sel_ok (GtkWidget	*w, GtkWidget *fsel) {
	gtk_entry_set_text(GTK_ENTRY(cPrefs->cresFont),
		gtk_font_selection_dialog_get_font_name (GTK_FONT_SELECTION_DIALOG(fsel)));

	gtk_widget_destroy (fsel);
}

void font_sel_cancel (GtkWidget *w, GtkWidget *fsel) {
	gtk_widget_destroy (fsel);
}

void font_sel(){

       GtkWidget *fs;
        
        fs = gtk_font_selection_dialog_new("Font");
        gtk_font_selection_dialog_set_font_name(GTK_FONT_SELECTION_DIALOG(fs), 
        gtk_entry_get_text(GTK_ENTRY(cPrefs->cresFont)));

	
        gtk_signal_connect(GTK_OBJECT(GTK_FONT_SELECTION_DIALOG(fs)->ok_button), "clicked",
                GTK_SIGNAL_FUNC(font_sel_ok), fs);
        gtk_signal_connect(GTK_OBJECT(GTK_FONT_SELECTION_DIALOG(fs)->cancel_button), "clicked",
                GTK_SIGNAL_FUNC(font_sel_cancel), fs);

        gtk_widget_show(fs);
}

void hide_window_WinSetup (void) {
	newfont = g_strdup (gtk_entry_get_text(GTK_ENTRY(cPrefs->cresFont)));
	if (newfont) {
	
		crescendo_set_font (ZVT_TERM(trmOutput), newfont);
	}
	
	gtk_widget_hide(WinSetup);
}

void show_window_WinSetup (void) {
	gtk_widget_show(WinSetup);
}


void crescendo_set_font (ZvtTerm *term, char *font_name){

	char *s;
	GdkFont *font;
	font = gdk_font_load (font_name);
	zvt_term_set_fonts  (term, font, font);
	if (font)
		zvt_term_set_fonts  (term, font, font);
		s = gtk_object_get_user_data (GTK_OBJECT (term));
        		if (s)
               g_free (s);
	gtk_object_set_user_data (GTK_OBJECT (term), g_strdup (font_name));
	zvt_term_set_font_name(ZVT_TERM(term), font_name);
	trmfont = font_name;
}




void app_end_with_save ( void) {
	
	hide_window_WinSetup();
	set_config();
	gnome_config_sync();	
}



void app_end_no_save (void) {
	hide_window_WinSetup();
}


void splash_button_cb (GtkWidget *widget, gpointer data) {
	if (GTK_TOGGLE_BUTTON (widget)->active){
		splash=1;
	}
	else {
		splash=0;
	}
}

void button_bar_cb (GtkWidget *widget, gpointer data) {
	if (GTK_TOGGLE_BUTTON(widget)->active){
		buttonbar=1;
	}
	else {
		buttonbar=0;
	}
}


/*Put all of the things we want to save from the preferences */
/*Dialog here in this function. */

void set_config (void) {
	
	gnome_config_push_prefix("/Crescendo/");
	gnome_config_set_string("Setup/trmfont", trmfont);
	gnome_config_set_int("Setup/splash", splash);
	gnome_config_set_int("Setup/buttonbar", buttonbar);
	
}


void setup_window_create (void) {
	
	GtkWidget *conSetup;
	GtkWidget *conHSetup;
	GdkPixmap *pixmap = NULL;
 	GdkBitmap *mask = NULL;
	GtkWidget *picSetup;
	GtkWidget *label;
	GtkWidget *butClose;
	GtkStyle *Style;
	GtkWidget *frmSetup;
	GtkWidget *conButtons;
	GtkWidget *butExit;
	
	GtkWidget *chkSound;
	GtkWidget *tblSetup;
	GtkWidget *frame1;
	GtkWidget *frame2;
	GtkWidget *frame4;
	GtkWidget *box1;
	GtkWidget *box2;
	GtkWidget *boxFont;
	GtkWidget *button;
	
	cPrefs = malloc(sizeof(cresPrefs));
	
	WinSetup = gtk_window_new (GTK_WINDOW_TOPLEVEL);
	
	gtk_widget_realize(WinSetup);
	
	conHSetup = gtk_hbox_new (FALSE, 0);
	conSetup = gtk_vbox_new ( FALSE, 0);

	gtk_container_add(GTK_CONTAINER(WinSetup), conHSetup);
	
	Style = gtk_widget_get_style(WinSetup);
	pixmap = gdk_pixmap_create_from_xpm_d(WinSetup->window, &mask, &Style->bg[GTK_STATE_NORMAL], (gchar**)cr_setup_xpm);
	picSetup = gtk_pixmap_new(pixmap, mask);
   	gtk_box_pack_start(GTK_BOX(conHSetup), picSetup, FALSE, FALSE, 0);
	
	gtk_widget_show(picSetup);
	
	gtk_box_pack_start(GTK_BOX(conHSetup), conSetup, FALSE, FALSE, 0);
	 
	frmSetup = gtk_frame_new("Crescendo Configuration Options");
	gtk_container_border_width (GTK_CONTAINER (frmSetup), 0);

	gtk_widget_set_usize( frmSetup, 400, 290);
	
	gtk_box_pack_start(GTK_BOX(conSetup), frmSetup, FALSE, FALSE, 0);
	gtk_widget_realize(frmSetup);
	 
	tblSetup = gtk_table_new( 2, 2, TRUE);
	gtk_container_add(GTK_CONTAINER(frmSetup), tblSetup);
	gtk_widget_show(tblSetup); 
	
	
	/* ----------FRAME 1 ---------------------*/
	frame1 = gtk_frame_new("Display Settings");
	gtk_container_border_width(GTK_CONTAINER(frame1), 2);
	gtk_table_attach_defaults( GTK_TABLE(tblSetup), frame1, 0, 1, 0, 1);
	gtk_widget_show(frame1);
	
	box1 = gtk_vbox_new(FALSE, 0);
	gtk_container_add(GTK_CONTAINER(frame1), box1);
	gtk_widget_show(box1);
	
	
	label = gtk_label_new("Crescendo Configuration");
	gtk_box_pack_start(GTK_BOX(box1), label, TRUE, FALSE, 0);
	gtk_widget_show(label);
	
	
	
	
	
	/* ----------FRAME 2 -----------------------*/
	frame2 = gtk_frame_new("Runtime Options");
	gtk_container_border_width(GTK_CONTAINER(frame2), 2);
	gtk_table_attach_defaults( GTK_TABLE(tblSetup), frame2, 1, 2, 0, 1);
	gtk_widget_show(frame2);
	
	box2 = gtk_vbox_new(FALSE, 0);
	gtk_container_add(GTK_CONTAINER(frame2), box2);
	gtk_widget_show(box2);
	
	
	chkSplash = gtk_check_button_new_with_label ("Enable Splash Screen");
	gtk_box_pack_start(GTK_BOX(box2), chkSplash, FALSE, FALSE, 0);
	if (splash==1){
		gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(chkSplash), TRUE);
	}
	else {
		gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(chkSplash), FALSE);
	}

	gtk_signal_connect ( GTK_OBJECT(chkSplash), "toggled", GTK_SIGNAL_FUNC(splash_button_cb), (gpointer) "toggle");
	gtk_widget_show(chkSplash);

	chkSound = gtk_check_button_new_with_label ("Enable Sound Support");
	gtk_box_pack_start(GTK_BOX(box2), chkSound, FALSE, FALSE, 0);
	gtk_widget_show(chkSound);
	
	chkButtonbar = gtk_check_button_new_with_label ("Enable Button Bar");
	gtk_box_pack_start(GTK_BOX(box2), chkSplash, FALSE, FALSE, 0);
	if (buttonbar==1){
		gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(chkButtonbar), TRUE);
	}
	else {
		gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(chkButtonbar), FALSE);
	}

	gtk_signal_connect ( GTK_OBJECT(chkButtonbar), "toggled", GTK_SIGNAL_FUNC(button_bar_cb), (gpointer) "toggle");
	gtk_widget_show(chkButtonbar);
	
	frame4 = gtk_frame_new("Font Selections:");

	
	gtk_container_border_width(GTK_CONTAINER(frame4), 2);
	gtk_box_pack_start(GTK_BOX(conSetup), frame4, FALSE, FALSE, 0);
	
	
	/* WARNING UNKNOWN SHIT HERE!!!!!!!!!!! */
	
	boxFont = gtk_hbox_new(FALSE, 0);
	gtk_container_add (GTK_CONTAINER (frame4), boxFont);
	gtk_container_border_width (GTK_CONTAINER (boxFont), 10);
	gtk_widget_show (boxFont);
		
	
	cPrefs->cresFont = gtk_entry_new ();
	gtk_box_pack_start(GTK_BOX(boxFont), cPrefs->cresFont, TRUE, TRUE, 0);
	gtk_entry_set_text(GTK_ENTRY(cPrefs->cresFont), trmfont);

	gtk_widget_show (cPrefs->cresFont);
  
	button = gtk_button_new_with_label ("Select...");
	gtk_signal_connect (GTK_OBJECT(button), "clicked",
   			  GTK_SIGNAL_FUNC(font_sel),
   			  NULL);
  
	gtk_box_pack_start(GTK_BOX(boxFont), button, FALSE, FALSE, 2);
  
	gtk_widget_show(button);

	gtk_widget_show(frame4);
  
	/* END OF WIERD SHIT */
	
	
	conButtons = gtk_hbox_new (FALSE, 0);
	gtk_container_add(GTK_CONTAINER(conSetup), conButtons);
	gtk_widget_show(conButtons);
	
	butExit = gtk_button_new_with_label ("Save & Exit");
	gtk_signal_connect ( GTK_OBJECT (butExit), "clicked", GTK_SIGNAL_FUNC (app_end_with_save), (gpointer) "Exit");
	gtk_box_pack_start(GTK_BOX(conButtons), butExit, TRUE, TRUE, 1);
	gtk_widget_show(butExit);
	
	butClose = gtk_button_new_with_label ("Exit");
     gtk_signal_connect (GTK_OBJECT (butClose), "clicked", GTK_SIGNAL_FUNC (app_end_no_save), (gpointer) "Save & Exit");
     gtk_box_pack_end(GTK_BOX(conButtons), butClose, TRUE, TRUE, 1);
     gtk_widget_show(butClose);
	
	
	
	gtk_widget_show(frmSetup);
	gtk_widget_show(conHSetup);
	gtk_widget_show(conSetup);
	
	gtk_widget_realize(WinSetup);
	gtk_window_position(GTK_WINDOW(WinSetup), GTK_WIN_POS_CENTER);
	
	
     return;
}






